datablock ProjectileData(CreepSMGKillProjectile : stablePaintProjectile)
{
   directDamage        = 0;
   impactImpulse       = 1300;
   verticalImpulse     = 1300;
   explosion           = stablePaintExplosion;
	particleEmitter     = wandEmitterA;

   muzzleVelocity      = 165;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "Creep Kill SMG";
};

datablock ItemData(CreepSMGKillGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	uiName = "CreepSMGKill";
	iconName = "base/client/ui/ItemIcons/printGun";
	doColorShift = true;
	colorShiftColor = "0.8 0.3 1 1.000";

	image = CreepSMGKillGunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CreepSMGKillGunImage : GunImage)
{
   shapeFile = "add-ons/weapon_gun/pistol.dts";
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = true;

   className = "WeaponImage";

   item = CreepSMGKillGunItem;
   ammo = " ";
   projectile = CreepSMGKillProjectile;
   projectileType = Projectile;
   melee = false;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";


	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Fire2";
	stateTimeoutValue[2]            = 0.17;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= GunFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[5]                    = "Fire2";
	stateTransitionOnTimeout[5]     = "Fire3";
	stateTimeoutValue[5]            = 0.18;
	stateFire[5]                    = true;
	stateAllowImageChange[5]        = false;
	stateSequence[5]                = "Fire";
	stateScript[5]                  = "onFire";
	stateWaitForTimeout[5]			= true;
	stateEmitter[5]					= GunFlashEmitter;
	stateEmitterTime[5]				= 0.05;
	stateEmitterNode[5]				= "muzzleNode";
	stateSound[5]					= gunShot1Sound;
	stateEjectShell[5]       = true;

	stateName[6]                    = "Fire3";
	stateTransitionOnTimeout[6]     = "Smoke";
	stateTimeoutValue[6]            = 0.19;
	stateFire[6]                    = true;
	stateAllowImageChange[6]        = false;
	stateSequence[6]                = "Fire";
	stateScript[6]                  = "onFire";
	stateWaitForTimeout[6]			= true;
	stateEmitter[6]					= GunFlashEmitter;
	stateEmitterTime[6]				= 0.05;
	stateEmitterNode[6]				= "muzzleNode";
	stateSound[6]					= gunShot1Sound;
	stateEjectShell[6]       = true;

	stateName[3] = "Smoke";
	//stateEmitter[3]					= GunSmokeEmitter;
	//stateEmitterTime[3]				= 0.05;
	//stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.10;
	stateTransitionOnTimeout[3]     = "Reload";
	stateWaitForTimeout[3]			= true;

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Cooldown";
	stateTransitionOnTriggerDown[4]	= "Fire";
	stateSequence[4]	= "Ready";

	stateName[7] = "Cooldown";
	stateEmitter[7]					= GunSmokeEmitter;
	stateEmitterTime[7]				= 0.30;
	stateEmitterNode[7]				= "muzzleNode";
	stateTimeoutValue[7]            = 0.30;
	stateTransitionOnTimeout[7]     = "Ready";
	stateWaitForTimeout[7]			= true;
	stateScript[7]                  = "onReady";

   doColorShift = true;
   colorShiftColor = CreepSMGKillGunItem.colorShiftColor;//"0.400 0.196 0 1.000";
   statetimeoutvalue[2] = 0.1;
};

function CreepSMGKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			if(!%c.damage){
				%c.damage+=3;
				Creepneardamage(%c,getrandom(1,25)/100);
			}
			%c.damage+=getrandom(1,35)/100;
			Creepneardamage(%c,getrandom(1,10)/100);
			%b.sourceobject.client.points++;
			if(%c.justforced) {
				%c.justforced = 0;
				%b.sourceobject.client.points+=1;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
				%b.sourceobject.client.kills++;
				%b.sourceobject.client.points += 25;
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen) %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
			}
		}
	}
}




datablock ProjectileData(CreepStuntKillProjectile : stablePaintProjectile)
{
   directDamage        = 0;
   impactImpulse       = 1300;
   verticalImpulse     = 1300;
   explosion           = stablePaintExplosion;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "Creep Stunt Kill";
};

datablock ItemData(CreepStuntKillGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	uiName = "CreepStuntKill";
	iconName = "base/client/ui/ItemIcons/printGun";
	doColorShift = true;
	colorShiftColor = "0.1 0.1 0.1 1.000";

	image = CreepStuntKillGunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CreepStuntKillGunImage : stableSprayCanImage)
{
   shapeFile = "base/data/shapes/printGun.dts";
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = false;

   className = "WeaponImage";

   item = CreepStuntKillGunItem;
   ammo = " ";
   projectile = CreepStuntKillProjectile;
   projectileType = Projectile;
   melee = true;

   doColorShift = true;
   colorShiftColor = CreepStuntKillGunItem.colorShiftColor;//"0.400 0.196 0 1.000";
   statetimeoutvalue[2] = 0.5;
};

function CreepStuntKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			//%c.damage++;
			if(!%c.isstunted){
				%c.damage+=4;
			}
			%b.sourceobject.client.points++;
			if(%c.justforced) {
				%c.justforced = 0;
				%b.sourceobject.client.points+=5;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
				%b.sourceobject.client.kills++;
				%b.sourceobject.client.points += 25;
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen){
					 %c.regentick = schedule($Creep::regenms*10, 0, "BrickRegen", %c);
					 %c.isstunted=1;
				}
			}
		}
	}
}



datablock ProjectileData(CreepExplosiveKillProjectile : stablePaintProjectile)
{
   directDamage        = 0;
   impactImpulse       = 1300;
   verticalImpulse     = 1300;
   explosion           = rainbowPaintExplosion;

   muzzleVelocity      = 95;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "Creep Explosive Kill";
};

datablock ItemData(CreepExplosiveKillGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "base/data/shapes/printGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	uiName = "CreepExplosiveKill";
	iconName = "base/client/ui/ItemIcons/printGun";
	doColorShift = true;
	colorShiftColor = "0.5 0.1 0.1 1.000";

	image = CreepExplosiveKillGunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CreepExplosiveKillGunImage : stableSprayCanImage)
{
   shapeFile = "base/data/shapes/printGun.dts";
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = false;

   className = "WeaponImage";

   item = CreepExplosiveKillGunItem;
   ammo = " ";
   projectile = CreepExplosiveKillProjectile;
   projectileType = Projectile;
   melee = true;

   doColorShift = true;
   colorShiftColor = CreepExplosiveKillGunItem.colorShiftColor;//"0.400 0.196 0 1.000";
   statetimeoutvalue[2] = 1.0;
};

function CreepExplosiveKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			%c.damage+=0.5;
			Creepneardamage3(%c,getrandom(10,35)/10,getrandom(10,25)/10);
			%b.sourceobject.client.points++;
			if(%c.justforced) {
				%c.justforced = 0;
				%b.sourceobject.client.points+=5;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
				%b.sourceobject.client.kills++;
				%b.sourceobject.client.points += 25;
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen){
					 %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
				}
			}
		}
	}
}

function BrickRegen(%brick)
{
	if(!isobject(%brick)) return;
	%brick.damage--;
	%brick.isstunted=0;
	if(%brick.damage < 0) %brick.damage = 0;
	%damlimit = ((3 - (CreepGroup.getcount()/1000)));
	if(%damlimit < 0) %damlimit = 0;
	%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
	%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
	%damstep = %damlimit / 10;
	if(%brick.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
		%color = mfloor((%damlimit - %brick.damage)/%damstep);
		if(%color > 9) %color = 9;
		if(%color < 0) %color = 0;
		%brick.setcolor(%color);
	}
	if(%brick.damage > 0) %brick.regentick = schedule($Creep::regenms, 0, "BrickRegen", %brick);
}


function Creepneardamage3(%brick,%damage,%d2){
	%pos = %brick.getposition();
	%x = getword(%pos, 0);
	%y = getword(%pos, 1);
	%z = getword(%pos, 2);
	%db = %brick.getdatablock();
	%bsx = (%brick.angleid % 2 == 0 ? %db.bricksizex : %db.bricksizey);
	%bsy = (%brick.angleid % 2 == 0 ? %db.bricksizey : %db.bricksizex);
	for(%j = 1; %j <= %bsx; %j++) {
		for(%k = 1; %k <= %bsy; %k++) {
			for(%l = 1; %l <= %db.bricksizez/3; %l++) {
				%tmpx = %x - ((%bsx - 1) * 0.25) + ((%j - 1) * 0.5);
				%tmpy = %y - ((%bsy - 1) * 0.25) + ((%k - 1) * 0.5);
				%tmpz = %z - ((%db.bricksizez/3 - 1) * 0.3) + ((%l - 1) * 0.6);
				%tmppos = %tmpx SPC %tmpy SPC %tmpz;
				if((%j == 1 && (%k == 1 || %l == 1)) || (%k == 1 && %l == 1)) {
					if(%l == 1) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
						if(%outcheck){
							Creepneardamage2(%outcheck,%damage);
							Creepneardamage(%outcheck,%d2);
						}
					}
					//if(%brick.cantgrow) {
						if(%j == 1) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
								Creepneardamage(%outcheck,%d2);
							}
						}
						if(%j == %bsx) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
								Creepneardamage(%outcheck,%d2);
							}
						}
						if(%k == 1) {						
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
								Creepneardamage(%outcheck,%d2);
							}
						}
						if(%k == %bsy) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
								Creepneardamage(%outcheck,%d2);
							}
						}
						if(%l == %db.bricksizez/3) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
								Creepneardamage(%outcheck,%d2);
							}
						}
					//}
				}
			}
		}
	}
}

function Creepneardamage(%brick,%damage){
	%pos = %brick.getposition();
	%x = getword(%pos, 0);
	%y = getword(%pos, 1);
	%z = getword(%pos, 2);
	%db = %brick.getdatablock();
	%bsx = (%brick.angleid % 2 == 0 ? %db.bricksizex : %db.bricksizey);
	%bsy = (%brick.angleid % 2 == 0 ? %db.bricksizey : %db.bricksizex);
	for(%j = 1; %j <= %bsx; %j++) {
		for(%k = 1; %k <= %bsy; %k++) {
			for(%l = 1; %l <= %db.bricksizez/3; %l++) {
				%tmpx = %x - ((%bsx - 1) * 0.25) + ((%j - 1) * 0.5);
				%tmpy = %y - ((%bsy - 1) * 0.25) + ((%k - 1) * 0.5);
				%tmpz = %z - ((%db.bricksizez/3 - 1) * 0.3) + ((%l - 1) * 0.6);
				%tmppos = %tmpx SPC %tmpy SPC %tmpz;
				if((%j == 1 && (%k == 1 || %l == 1)) || (%k == 1 && %l == 1)) {
					if(%l == 1) {
						%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 -0.85"), $GrowMasks);
						if(%outcheck){
							Creepneardamage2(%outcheck,%damage);
						}
					}
					//if(%brick.cantgrow) {
						if(%j == 1) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "-0.65 0 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
							}
						}
						if(%j == %bsx) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0.65 0 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
							}
						}
						if(%k == 1) {						
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 -0.65 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
							}
						}
						if(%k == %bsy) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0.65 0"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
							}
						}
						if(%l == %db.bricksizez/3) {
							%outcheck = ContainerRayCast(%tmppos, vectoradd(%tmppos, "0 0 0.85"), $GrowMasks);
							if(%outcheck){
								Creepneardamage2(%outcheck,%damage);
							}
						}
					//}
				}
			}
		}
	}
}

function Creepneardamage2(%c,%damage){
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			%c.damage+=%damage;
			if(%c.justforced) {
				%c.justforced = 0;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen){
					 %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
				}
			}
		}
	}
}





datablock ProjectileData(CreepShotgunKillProjectile : swirlPaintProjectile)
{
   directDamage        = 0;
   impactImpulse       = 1300;
   verticalImpulse     = 1300;
   explosion           = swirlPaintExplosion;

   muzzleVelocity      = 90;
   velInheritFactor    = 1;
	particleEmitter     = wandEmitterA;

   armingDelay         = 0;
   lifetime            = 200;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
   
   uiName = "Creep Shotgun Kill";
};

datablock ItemData(CreepShotgunKillGunItem)
{
	category = "Weapon";
	className = "Weapon";

	shapeFile = "./shotgun1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = false;

	uiName = "CreepShotgunKill";
	iconName = "Add-ons/Weapon_Gun/gun";
	doColorShift = true;
	colorShiftColor = "0.1 0.1 0.1 1.000";

	image = CreepShotgunKillGunImage;
	canDrop = true;
};

datablock ShapeBaseImageData(CreepShotgunKillGunImage : swirlSprayCanImage)
{
   shapeFile = "./shotgun1.dts";
   emap = false;

   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = "0.7 1.2 -0.55";
   rotation = eulerToMatrix( "0 0 0" );

   correctMuzzleVector = false;

   className = "WeaponImage";

   item = CreepShotgunKillGunItem;
   ammo = " ";
   projectile = CreepShotgunKillProjectile;
   projectileType = Projectile;
   //melee = true;

   doColorShift = true;
   colorShiftColor = CreepShotgunKillGunItem.colorShiftColor;//"0.400 0.196 0 1.000";
   statetimeoutvalue[2] = 0.9;
};
function CreepShotgunKillGunImage::onFire(%this,%obj,%slot)
{
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%typer="CreepShotgunKillProjectile";
	%spread = 0.0038;
	%pvec = %obj.client.player.getvelocity();
	if(getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) > 1 || getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) < -1){
		%spread += 0.0008;
	}else{
		%spread -= 0.0008;
	}
	%shellcount=6;
	%scale="1 1 1";
	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%bonus);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		

		%p = new (%this.projectileType)()
		{
			dataBlock = %typer;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		%p.setscale(%scale);
		MissionCleanup.add(%p);
	}
	return %p;
	

}

function CreepShotgunKillProjectile::OnCollision(%a, %b, %c, %d, %e, %f, %g)
{
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			//%c.damage++;
			%c.damage+=1.5;
			%b.sourceobject.client.points++;
			if(%c.justforced) {
				%c.justforced = 0;
				%b.sourceobject.client.points+=5;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
				%b.sourceobject.client.kills++;
				%b.sourceobject.client.points += 25;
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen){
					 %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
				}
			}
		}
	}
}
$creepdammod=0.5;
package newcreepkill_test1{
function ProjectileData::onCollision(%a, %b, %c, %d, %e, %f, %g){
	if(isobject(CreepGroup)) {
		if(CreepGroup.ismember(%c) && $Creep::Active && !CreepGroup.owner.minigame.betweenwaves && Creepgroup.owner.minigame == %b.sourceobject.client.minigame) {
			if(iseventpending(%c.regentick)) cancel(%c.regentick);
			%dam=%a.directdamage;
			%mod=getrandom(15,25);
			%min=(%dam-%mod);
			%max=(%dam+(%mod/2));
			%c.damage+=(getrandom(%min,%max)/100)+$creepdammod;
			%b.sourceobject.client.points++;
			if(%c.justforced) {
				%c.justforced = 0;
				%b.sourceobject.client.points+=1;
			}
			%damlimit = ((3 - (CreepGroup.getcount()/1000)));
			if(%damlimit < 0) %damlimit = 0;
			%damlimit = (%damlimit + 5) * ($Creep::scalehp ? CreepGroup.owner.minigame.playercount : 1);
			%damlimit += mfloor(%damlimit * (CreepGroup.owner.minigame.wave - 1) * 0.2);
			if(%c.damage >= %damlimit) {
				%c.killbrick();
				%b.sourceobject.client.kills++;
				%b.sourceobject.client.points += 25;
			} else {
				%damstep = %damlimit / 10;
				if(%c.colorid * %damstep != %damlimit && $Creep::ColorMode == 0) {
					%color = mfloor((%damlimit - %c.damage)/%damstep);
					if(%color < 0) %color = 0;
					%c.setcolor(%color);
				}
				if($Creep::regen) %c.regentick = schedule($Creep::regenms, 0, "BrickRegen", %c);
			}
		}
	}
	Parent::onCollision(%a, %b, %c, %d, %e, %f, %g);
}
};
activatepackage(newcreepkill_test1);